Index: src/uk/me/parabola/imgfmt/app/mdr/MDRFile.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/MDRFile.java	(revision 4867)
+++ src/uk/me/parabola/imgfmt/app/mdr/MDRFile.java	(working copy)
@@ -243,33 +243,31 @@
 				continue;
 			
 			String name = lab.getText();
+			String strippedName = name;
 			if (!mdr7Del.isEmpty()) {
-				String[] parts = name.split(" ");
-				int pos = parts.length;
-				for (int i = parts.length - 1; i >= 0; i--) {
+				String[] parts = strippedName.split(" ");
+				StringBuilder sb = new StringBuilder();
+				boolean changed = false;
+				for (int i = 0; i < parts.length; i++) {
 					if (!mdr7Del.contains(parts[i])) {
-						break;
+						sb.append(parts[i]).append(' ');
+					} else {
+						changed = true;
 					}
-					pos = i;
 				}
-				if (pos == 0)
-					continue;
-				if (pos < parts.length) {
-					StringBuilder sb = new StringBuilder();
-					for (int i = 0; i + 1 < pos; i++) {
-						sb.append(parts[i]);
-						sb.append(" ");
-					}
-					sb.append(parts[pos - 1]);
-					name = sb.toString(); // XXX maybe add -intern()
+				if (changed) {
+					if (sb.length() == 0)
+						continue;
+					sb.setLength(sb.length() - 1);
+					strippedName = sb.toString();
 				}
 			}
-			
-			int strOff = createString(name);
 
+			int strOff = createString(strippedName);
+
 			// We sort on the dirty name (ie with the Garmin shield codes) although those codes do not
 			// affect the sort order. The string for mdr15 does not include the shield codes.
-			mdr7.addStreet(currentMap, name, lab.getOffset(), strOff, mdrCity);
+			mdr7.addStreet(currentMap, strippedName, lab.getOffset(), strOff, mdrCity);
 		}
 	}
 
